/***** **** *** ** *  *   *    *     *       *     *   *  * ** *** **** *****\

    logresolve 2.0 - http://www.uunet.ca/~tomr/progs/logresolve/

    logresolve.h - configuration & global structures 2.0c1

    Tom Rathborne - tomr@uunet.ca - http://www.uunet.ca/~tomr/

\***** **** *** ** *  *   *    *     *       *     *   *  * ** *** **** *****/

#ifndef LOGRESOLVE_H
#define LOGRESOLVE_H

/****************************************************************************\
\*** User-configurable things ***********************************************/

/*
 * Turn DBM caching on/off
 */

#define LR_DBM

/*
 * Default DBM filename (typically just a prefix)
 */

#define LR_DBMNAME "LR"

/*
 * Default lockfile name (currently useless)
 */

#define LR_LOCKNAME "LR.lock"

/*
 * Expire time for items in cache - in seconds (604800 = 1 week)
 */

#define LR_EXPIRE 604800

/*
 * Default number of buckets in cache hash table (passed to lr-hash.h)
 * This should be big & PRIME, or at least not a power of 2. 
 */

#define LR_BUCKETS 1723

/*
 * maximum line length, including \0 
 */

#define MAXLINE 1024

/****************************************************************************\
\*** You shouldn't (need to) change anything below this line ****************/

/*
 * Boolean constants - probably defined elsewhere but hey - what the heck!
 */

#define TRUE 1
#define FALSE 0

/*
 * Maximum length of an IP number as a string, including \0 
 * (e.g. "255.255.255.255" = 16 bytes)
 */

#define IPSTRLEN 16

/*
 * flags for DBM mode
 */

#define LR_READ 0
#define LR_WRITE 1
#define LR_CLOSED 2

#endif

/*** end of logresolve.h ***/
