/***** **** *** ** *  *   *    *     *       *     *   *  * ** *** **** *****\

    logresolve 2.0 - http://www.uunet.ca/~tomr/progs/logresolve/

    lr-nsrec.h - configuration & global structures 2.0n0

    Tom Rathborne - tomr@uunet.ca - http://www.uunet.ca/~tomr/

\***** **** *** ** *  *   *    *     *       *     *   *  * ** *** **** *****/

#ifndef LR_NSREC_H
#define LR_NSREC_H

#include "logresolve.h"

/*
 *  struct nsrec - cached record of nameservice
 *
 *  ipnum - IP number
 *  hostname - hostname
 *  noname - nonzero iff IP number has no hostname, (so hostname=IP number)
 *  lookuptime - when last looked up
 *  usagecount - times this record has been used
 *
 *  next - pointer to next record in linked list (for hash-table cache)
 */

struct nsrec {
    unsigned char ipnum[4];
    char *hostname;
    int noname;
    int lookuptime;
    int usagecount;

    struct nsrec *next;
};

/*
 * nsrec_new - mallocs a new record
 */

struct nsrec *nsrec_new();

/*
 * nsrec_del - frees a record
 */

void nsrec_del(struct nsrec *record);

#endif

/*** end of lr-nsrec.h ***/
